
/***************************************************************************
                 module classe ua_dynzdf_imp.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, April 17, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{ /*  	1	from	zwisd_ua_dynzdf_imp	2  i 	j    k	  t
     	2	from	ua_dynzdf_imp		1  i 	j    k+1  t
    	3	from	ua_de_dynzdf_imp	1  i 	j    k	  t
     	4	from	zwt_ua_dynzdf_imp	1  i 	j    k	  t*/

  /* YS1 ua */
  /*     A 2.044794301666928e-07
	 R 2.796970475088184e-10*/

  /* YS1 va clonol */
  /*          2.045062181204865e-07
	      2.284016994356648e-10*/

  if(Yt==TU)
    YS1=0.;
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
    }
    else{
      if(Yk==NZ-2)
	YS1= x3/x4;
      else
	YS1=(x3-x1*x2)/x4;
    }
  }
  //
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{
  //   if(Yt==3 && Yi==28 && Yj==3)  xtest("ua_dynzdf YG1",YG1,Yi,Yj,Yk,Yt);
  YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;
  if(Yt!=TU){  
    
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
      YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;
    }
    else{
      if(Yk==NZ-2){
	YJ1I1=0.;    
	YJ1I2=0.;
	YJ1I3=1./x4;
	YJ1I4=-x3/x4/x4;
      }
      else{
	YJ1I1=-x2/x4;
	YJ1I2=-x1/x4;
	YJ1I3=1./x4;
	YJ1I4=-(x3-x1*x2)/x4/x4;
      }
    }
  }
  //
}

//===========================================================================
//*********************  FIN DU MODULE ua_dynzdf_imp   **********************

