
/***************************************************************************
                 module classe ua_vor_ene.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 9, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6,YREAL x7)
{/*	1	from	ua_dynadv_cen2		1  i    j    k    t
	2	from	zwxyz_vor_ene		3  i    j-1  k    t
	3	from	zwxyz_vor_ene		3  i    j    k    t
	4	from	zwxyz_vor_ene		2  i    j-1  k    t
	5	from	zwxyz_vor_ene		2  i    j    k    t
	6	from	zwxyz_vor_ene		2  i+1  j-1  k    t
	7	from	zwxyz_vor_ene		2  i+1  j    k    t*/
  /*YS1*/
  /*     1.258248811116506e-12
	 1.604676681128015e-08*/
  /*  if (Yi==30 && Yj==1 && Yk==0 && Yt<13)
  {
    printf("ua_vor_ene:Yt=%i,x1=%f,x2=%f,x3=%f, x4=%f, x5=%f ,x6=%f, x7=%f\n",Yt,x1,x2,x3,x4,x5,x6,x7);
    }    */

if(Yt==TU)
    YS1=0.;
  else{
    double zfact2=0.5*0.5;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1)
      YS1=0.;
    else{
      double zy1=x4+x6;
      double zy2=x5+x7;
      YS1=x1+zfact2/e1u(Yi,Yj)*(x2*zy1+x3*zy2);
    }
  }
  //  
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6,YREAL x7)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.;   YJ1I6=0.;   YJ1I7=0.;
  if(Yt!=TU){  
    double zfact2=0.5*0.5;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1){
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.;   YJ1I6=0.;   YJ1I7=0.;
    }
    else{
      double zy1=x4+x6;
      double zy2=x5+x7;
      YJ1I1=1.;
      YJ1I2=zfact2/e1u(Yi,Yj)*zy1;
      YJ1I3=zfact2/e1u(Yi,Yj)*zy2;
      YJ1I4=zfact2/e1u(Yi,Yj)*x2;
      YJ1I5=zfact2/e1u(Yi,Yj)*x3;
      YJ1I6=zfact2/e1u(Yi,Yj)*x2;
      YJ1I7=zfact2/e1u(Yi,Yj)*x3;
    }
  }
  //  
  
}

//===========================================================================
//************************ FIN DU MODULE ua_vor_ene *************************
