
/***************************************************************************
                 module classe sum_spgv_dynspg_flt.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, April 20, 2009
//===========================================================================
//                          methode forward
forward ()
{ /*	1..NZ	from	va_1_dynspg_flt		1  i 	j   1..NZ */

  /* YS1  */
  /*     A 
	 R */
  if(Yt==TU)
    YS1=0.;
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1  ){
      YS1=0.;
    }
    else{
      double sum=0.;
      for(int k=0;k<NZ-1;k++)
	sum=sum+ fse3v(Yi,Yj,k) * Yting[k];
      YS1=sum * e1v(Yi,Yj);  
    }
  }
  //
}

//===========================================================================
//                         methode  backward

backward ()
{
  for(int k=0;k<NZ;k++)  Yjac[0][k]    =0.;
  if(Yt!=TU){  
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1  ){
      for(int k=0;k<NZ;k++)  Yjac[0][k]    =0.;
    }
    else{
      for(int k=0;k<NZ-1;k++)  Yjac[0][k]    =fse3v(Yi,Yj,k)*e1v(Yi,Yj);
    }
  }
  //
  
}

//===========================================================================
//******************  FIN DU MODULE sum_spgv_dynspg_flt   *******************

